package com.andbase.adapter;




import java.util.List;
import java.util.Map;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;

import com.ab.global.AbConstant;
import com.ab.net.AbImageDownloadCallback;
import com.ab.net.AbImageDownloadItem;
import com.ab.net.AbImageDownloadQueue;
import com.ab.util.AbFileUtil;
import com.ab.util.AbStrUtil;
import com.andbase.global.Constant;
/**
 * Copyright (c) 2011 All rights reserved
 * ƣMyListViewAdapter
 * AdapterͷBitmap
 * @author zhaoqp
 * @date 2011-12-10
 * @version
 */
public class ImageListAdapter extends BaseAdapter{
	
	private static String TAG = "ImageListAdapter";
	private static final boolean D = Constant.DEBUG;
  
	private Context mContext;
	//xmlתView
    private LayoutInflater mInflater;
    //еĲ
    private int mResource;
    //бչֵ
    private List mData;
    //Mapеkey
    private String[] mFrom;
    //viewid
    private int[] mTo;
    private AbImageDownloadQueue mAbImageDownloadQueue = null;
    
   /**
    * 췽
    * @param context
    * @param data бչֵ
    * @param resource еĲ
    * @param from Mapеkey
    * @param to viewid
    */
    public ImageListAdapter(Context context, List data,
            int resource, String[] from, int[] to){
    	this.mContext = context;
    	this.mData = data;
    	this.mResource = resource;
    	this.mFrom = from;
    	this.mTo = to;
        //ڽxmlתΪView
        this.mInflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        this.mAbImageDownloadQueue = AbImageDownloadQueue.getInstance();
    }   
    
    @Override
    public int getCount() {
        return mData.size();
    }
    
    @Override
    public Object getItem(int position) {
        return mData.get(position);
    }

    @Override
    public long getItemId(int position){
      return position;
    }
    
    @Override
    public View getView(int position, View convertView, ViewGroup parent){
    	  final ViewHolder holder;
          if(convertView == null){
	           //ʹԶlist_itemsΪLayout
	           convertView = mInflater.inflate(mResource, parent, false);
	           //findViewĴ
			   holder = new ViewHolder();
	           //ʼеԪ
			   holder.itemsIcon = ((ImageView) convertView.findViewById(mTo[0])) ;
			   holder.itemsTitle = ((TextView) convertView.findViewById(mTo[1]));
			   holder.itemsText = ((TextView) convertView.findViewById(mTo[2]));
			   convertView.setTag(holder);
          }else{
        	   holder = (ViewHolder) convertView.getTag();
          }
          
		  //ȡе
          final Map<String, Object>  obj = (Map<String, Object>)mData.get(position);
          String imageUrl = (String)obj.get("itemsIcon");
          holder.itemsTitle.setText((String)obj.get("itemsTitle"));
          holder.itemsText.setText((String)obj.get("itemsText"));
          if(!AbStrUtil.isEmpty(imageUrl)){
        	  // 
              AbImageDownloadItem item = new AbImageDownloadItem(); 
    	      //ʾĴС
    	      item.width = 80;
    	      item.height = 80;
    	      //Ϊ
    	      item.type = AbConstant.SCALEIMG;
    	      item.imageUrl = imageUrl;
    	     
              holder.itemsIcon.setImageBitmap(AbFileUtil.getBitmapFormSrc("image/image_loading.png"));
    	      //ɺ½
    	      item.callback = new AbImageDownloadCallback() { 
    	            @Override 
    	            public void update(Bitmap bitmap, String imageUrl) { 
    	            	if(bitmap!=null){
    	            		holder.itemsIcon.setImageBitmap(bitmap); 
    	            	}else{
    	            	    holder.itemsIcon.setImageBitmap(AbFileUtil.getBitmapFormSrc("image/image_error.png"));
    	            	}
    	            } 
    	      }; 
    	      mAbImageDownloadQueue.download(item); 
          }else{
        	  holder.itemsIcon.setImageBitmap(AbFileUtil.getBitmapFormSrc("image/image_no.png"));
          }
          
          return convertView;
    }
    
    /**
	 * ViewԪ
	 */
	static class ViewHolder {
		ImageView itemsIcon;
		TextView itemsTitle;
		TextView itemsText;
		ImageButton itemsBtn;
	}
    
}